/*#######################################################################################
AVR Small Webserver 
Copyright (C) 2004 Ulrich Radig
Copyright (C) 2005 Joachim Brke

In dieser Datei wird der GET-request bearbeitet

#######################################################################################*/

#include "main.h"
#include <webpage.h> 
#include "OWIPolled.h"
#include "OWIcrc.h"

//#######################################################################################
unsigned char searchParameter(unsigned char * param, unsigned char * buffer, 
			unsigned char bufferlen, unsigned char datum) 
//#######################################################################################
{ 
	unsigned int len = strlen(param); 
	unsigned int i; 
	unsigned char * j;
	for(i=0;i<bufferlen-len-1;i++) // Anfang des Parameters suchen
	{ 
		if(memcmp(buffer+i,param,len)==0 		// wenn der Parameter gefunden wurde
			&& buffer[i+len]=='=' 		// und am Ende ein =
			&& (buffer[i-1]=='?'		// und davor ein ?
			||buffer[i-1]=='&'			//   oder ein &
			||buffer[i-1]==0))		//   oder eine 0 stehen, dann ...
		{ 
			i += len+1; 			// Anfang des Parameterwertes = Anfangparametername + Lnge + 1
			j = buffer+i;			// j zeigt auf das erste Zeichen des Parameterwertes
			while(*j != 0 && *j != '&' && *j != ' ')  j++; //Ende des Parameterwertes suchen
			*j=0;					// 0 hinter den Parameterwert schreiben und String abschlieen
			datum = atoi(buffer+i);
			return(datum);
	 	} 
	}
	return(datum); 	
}

//#######################################################################################
void searchName(unsigned char * param, unsigned char * buffer, 
			unsigned char bufferlen) 
//#######################################################################################
{ 
	unsigned int len = strlen(param); 
	unsigned int i; 
	char k, l;
	unsigned char * j;
	for(i=0;i<bufferlen-len-1;i++) // Anfang des Parameters suchen
	{ 
		if(memcmp(buffer+i,param,len)==0 		// wenn der Parameter gefunden wurde
			&& buffer[i+len]=='=' 		// und am Ende ein =
			&& (buffer[i-1]=='?'		// und davor ein ?
			  ||buffer[i-1]=='&'		//   oder ein &
			  ||buffer[i-1]==0))		//   oder eine 0 stehen, dann ...
		{ 
			i += len+1; 			// Anfang des Parameterwertes = Anfangparametername + Lnge + 1
			j = buffer+i;			// j zeigt auf das erste Zeichen des Parameterwertes
			for (k=8;k<16;k++) {
				if (*j != 0 && *j != '&' && *j != ' ') {
					if (*j=='+') l = ' ';	// Leerzeichen vom Browser
					else if (*j=='*') {	// Token
						j++;
						l = *j;
						l -= (l>'9') ? 'A'-10 : '0';	// Zeichen ist Index des Tokens
					}
					else l = *j; 			// druckbares Zeichen
					j++;
				}
				else l = 0xff;				// mit "FF" auffllen
				eeprom_write_byte((char *)(Index<<4)+k,l);
			}
	 	} 
	}
}

//#######################################################################################
void httpd (char* buffer,int *bufferlen)
//#######################################################################################
{
	char i;
	unsigned int tcpdata;
	
//Errechnet Startpunkt der Daten im Tcp buffer
//IP Headerlnge + TCP Headerlnge + Ethernetframe
 tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer

	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)==1)
	{
		return;//keine Daten fr Anwendung
	}

	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
	
	//berprft HTTP Header 
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1) {
		
		// Get-Daten auswerten 	
		pointerold = Page0;				// Pointerold auf Fehlerseite setzen
		
		unsigned char File_Name[13];	//File_Name entspricht 8.3 & Endmakierung
		
		//berprft Header nach "GET /File_Name HTTP....."
		if ( memcmp(&buffer[tcpdata],"GET /",5) == 0) 
		{
			char *tmppointer = &buffer[tcpdata + 5];
			unsigned char counter = 0;
			//Der Header wird durchsucht beginnend bei "GET /" bis zum nchsten Space oder "?"
			while ((* tmppointer != 0x20) & (* tmppointer != '?'))
			{
				File_Name[counter] = *tmppointer++;
				counter++;
			}
			File_Name[counter] = '\0';			//Endmarkierung setzen
			
			if (File_Name[0] == '\0') 		//Enthlt der Header keinen File Namen wird dieser Index.htm
				memcpy(File_Name,"index.htm\0",10);
				
			printf(File_Name);
			printf("\n");
			
#if USE_MMC
			//Root Verzeichnis nach File Namen durchsuchen
			unsigned char Dir_Attrib;
			
			//Lade Cluster fr das File welches in File_Name steht 
			tcp_socket->Cluster = 0; //suche im Root Directory
			if (Search_File(File_Name, 
					&tcp_socket->Cluster, 
					&tcp_socket->File_Size,
					&Dir_Attrib, 
					&buffer[tcpdata]) == 1)
				tcp_socket->File_Block_Counter = 0;
			else
				tcp_socket->Cluster = 0;
				//wurde das File nicht gefunden, wird eine Seite aus Flashspeicher angezeigt
#endif //USE_MMC
			
		}	// Ende if "GET /"
		
		if (memcmp(File_Name,"index.htm",   9) == 0) pointerold = Page1;
		if (memcmp(File_Name,"temp.htm",    8) == 0) pointerold = Page2;
		if (memcmp(File_Name,"dump.htm",    8) == 0) pointerold = Page3;
		if (memcmp(File_Name,"einst.htm",   9) == 0) pointerold = Page4;
		if (memcmp(File_Name,"name.htm",    8) == 0) pointerold = Page5;
		if (memcmp(File_Name,"tg.jpg",      6) == 0) pointerold = Picture1;
		if (memcmp(File_Name,"favicon.ico",11) == 0) pointerold = Picture2;
		
		// Abfragen, ob Parameter zurckgegeben wurden
		// gfs. die Variablen entsprechend setzen
		hh =searchParameter("VAh",buffer+tcpdata,*bufferlen-tcpdata,hh); 
		mm =searchParameter("VAm",buffer+tcpdata,*bufferlen-tcpdata,mm); 
		ss =searchParameter("VAs",buffer+tcpdata,*bufferlen-tcpdata,ss); 
		
		VA2=searchParameter("VA2",buffer+tcpdata,*bufferlen-tcpdata,VA2); 
		VA3=searchParameter("VA3",buffer+tcpdata,*bufferlen-tcpdata,VA3);
		
		VA4=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA4);	// Checkbox lschen
		VA4=searchParameter("VA4",buffer+tcpdata,*bufferlen-tcpdata,VA4); 
		
		VA5=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA5); // Checkbox lschen
		VA5=searchParameter("VA5",buffer+tcpdata,*bufferlen-tcpdata,VA5); 
		
		VA6=searchParameter("VA0",buffer+tcpdata,*bufferlen-tcpdata,VA6);	// Checkbox lschen 
		VA6=searchParameter("VA6",buffer+tcpdata,*bufferlen-tcpdata,VA6); 
		
		VAi=searchParameter("VAi",buffer+tcpdata,*bufferlen-tcpdata,VAi); 
		VAj=searchParameter("VAj",buffer+tcpdata,*bufferlen-tcpdata,VAj); 
		VAk=searchParameter("VAk",buffer+tcpdata,*bufferlen-tcpdata,VAk); 
		VAl=searchParameter("VAl",buffer+tcpdata,*bufferlen-tcpdata,VAl);
		
		VAR=searchParameter("VAR",buffer+tcpdata,*bufferlen-tcpdata,VAR); 
		Index=searchParameter("VAL",buffer+tcpdata,*bufferlen-tcpdata,Index); 
		
		searchName("VAN",buffer+tcpdata,*bufferlen-tcpdata); 
		
		VA0=searchParameter("DELETE",buffer+tcpdata,*bufferlen-tcpdata,0xff); 
		if ((VA0 < MAX_DEVICES)	// Nummer im zulssigen Bereich ?
			&& (VA0 == Index)		// identisch mit dem Index ?
			&& (VA0!=0xff)) {		// und korrekt gesetzt ?
			for (i=0;i<16;i++)	// Datensatz mit "ff" berschreiben
			  eeprom_write_byte((uint8_t *)(VA0<<4)+i,0xff);
			DALLAS[VA0][0]=0x7f;	// "Eintrag ist leer" setzen
			DALLAS[VA0][1]=0xff;	// Baustein ist kein Thermometer
		}
		
		// Wenn Aktionen erforderlich sind, werden diese hier durchgefhrt
		//
		if (VA4) DALLAS[0][0] |= OWI_PIN_4; else DALLAS[0][0] &= (~OWI_PIN_4);
		if (VA5) DALLAS[0][0] |= OWI_PIN_5; else DALLAS[0][0] &= (~OWI_PIN_5);
		if (VA6) DALLAS[0][0] |= OWI_PIN_6; else DALLAS[0][0] &= (~OWI_PIN_6);
		
		if (	(VAi != eeprom_read_byte((char *)(char)0+IPoffset)) 
			||	(VAj != eeprom_read_byte((char *)(char)1+IPoffset)) 
			||	(VAk != eeprom_read_byte((char *)(char)2+IPoffset))
			||	(VAl != eeprom_read_byte((char *)(char)3+IPoffset)) ) { // Wenn die IP-Adresse verndert wurde
			eeprom_write_byte((char *)(char)0+IPoffset,VAi);			// Neue IP-Adresse ins EEPROM schreiben
			eeprom_write_byte((char *)(char)1+IPoffset,VAj);
			eeprom_write_byte((char *)(char)2+IPoffset,VAk);
			eeprom_write_byte((char *)(char)3+IPoffset,VAl);
			unsigned char CRC=0;
			for (i=0; i<4; i++) 
				CRC=OWI_ComputeCRC8(eeprom_read_byte((char *)(char)IPoffset+i),CRC);	// CRC ermitteln
			eeprom_write_byte((char *)(char)4+IPoffset,CRC);				// und ins EEPROM schreiben
		}
		
		OCR2 = VA2; // LED im PWM-Betrieb einstellen 
		
		/* LED an der Portleitung einfach nur ein- oder ausschalten
		if (VA2) LED_LINES |= (1<<LED_PIN); // LED einschalten
		    else LED_LINES &= (0<<LED_PIN); // LED ausschalten	*/
		
		tcp_store(buffer);								//speichert Sequenzcounter und Acknowledgecounter
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;	//setzen des Ack Flags und PSH Flags
		
		
		// tcp_add_data (HTTP_OK1,buffer,bufferlen);		// HTTP OK Paket erzeugen 
		if (strstr(File_Name,".ico")) 
			tcp_add_data (HTTP_ico,buffer,bufferlen);
		else 
			if (strstr(File_Name,".jpg")) 
				tcp_add_data (HTTP_jpg,buffer,bufferlen);
			else  
				tcp_add_data (HTTP_html,buffer,bufferlen);
		
		tcp_make(buffer);								//erzeugt ein TCP Packet 
		Write_Ethernet_Frame (buffer,*bufferlen);		//sendet das erzeugte TCP Packet 
		
		//(Ethernet Frame war voll) weiterer Frame mu gesendet werden!
		tcp_socket->Status = TCP_SOCKET_OPEN2;
		tcp_socket->Pointer = pointerold;
		return;
	}
	
	//Senden der Webseite bzw. Daten war noch nicht Fertig (Ethernet Frame war aber voll)	
	if (tcp_socket->Status == TCP_SOCKET_OPEN2) 
	{
		unsigned char Buffer_Full = 0;
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;	//Setzen des Ack Flags und PSH Flags	
		tcp_store(buffer);								//Speichert Sequenzcounter und Aknowledgecounter
		//erzeugt Seiten Packet
		
#if USE_MMC
		if(tcp_socket->Cluster != 0)
		{
			Read_File (tcp_socket->Cluster,&buffer[tcpdata],tcp_socket->File_Block_Counter);
			tcp_socket->File_Block_Counter++;
			if (tcp_socket->File_Size > (unsigned long)512)
			{
				Buffer_Full = 1; //es wurden noch nicht alle Daten gesendet
				(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - 512;
				TCP_New_Packtlen (buffer,bufferlen,tcpdata + 512);
			}
			else
			{
				Buffer_Full = 0; //es wurden alle Daten gesendet
				TCP_New_Packtlen (buffer,bufferlen,tcpdata + tcp_socket->File_Size);
			}
			goto endmakepacket;
		}
#endif //USE_MMC
		
		pointerold = tcp_socket->Pointer;
		Buffer_Full = tcp_add_data (pointerold,buffer,bufferlen);
		tcp_socket->Pointer = pointerold;
		
#if USE_MMC
		endmakepacket:
#endif //USE_MMC
		
		tcp_make(buffer);							//Erzeugt ein TCP Packet
		Write_Ethernet_Frame (buffer,*bufferlen);	//Sendet das erzeugte TCP Packet 
		if (Buffer_Full == 0) {
#if USE_MMC
			tcp_socket->Cluster = 0;
#endif //USE_MMC
			tcp_socket->Status = TCP_SOCKET_CLOSE;
		}
		return;		
	}
return;
}


